View Issue Details

IDProjectCategoryView StatusLast Update
0028414CommunityOCCT:Data Exchangepublic2022-04-27 14:03
Reportergdw Assigned Toatereshi  
PrioritynormalSeveritymajor 
Status assignedResolutionopen 
PlatformMacOSOS 
Product Version6.9.1 
Target Version7.7.0 
Summary0028414: Data Exchange - Step entity not correctly read
DescriptionHello,
We have identified an entity (STEP TOROIDAL_SURFACE) that is not correctly read (see the screen shots of IDA-Step and FreeCAD).
We have isolated the entity in a as small as possible Step file in order to help the correction.
Thank in advance for your help.
--
Guilhem
Steps To ReproduceTest "bugs step bug28414".
TagsNo tags attached.
Test case numberNot required

Attached Files

  • StepBug.zip (507,140 bytes)
  • bug_tore.stp (15,501 bytes)
  • Capture d’écran 2018-05-01 à 16.32.27.png (49,193 bytes)
  • Capture d’écran 2018-05-01 à 16.32.54.png (84,779 bytes)
  • bug28414.stp (15,505 bytes)

Relationships

related to 0029564 closedbugmaster Community Data Exchange - STEP Import and Export failure 
related to 0027722 assigneddpasukhi Community Data Exchange - STEP error for Ellipse revol shape 

Activities

gdw

2017-01-30 19:28

developer  

StepBug.zip (507,140 bytes)

abv

2017-01-31 09:47

manager   ~0063235

Among available STEP viewers:
- Autodesk A360 and GOM Inspect (based on Hoops by TechSoft3D), PTC Creo Elements show this face as almost full torus;
- OCCT, FreeCAD, RGK show it as small part;
- Rhino fails to open it;
- STEP NC shows broken shape.

Thus translation of toruses to and from STEP definitely deserves to be checked.

gdw

2018-01-02 12:25

developer   ~0073218

Hello,
What is the status of this issue?
Thks in advance
--
gdw

eryar

2018-01-04 04:34

developer   ~0073228

Hi gdw,

I think this may have relationships with 0027722:
https://tracker.dev.opencascade.org/view.php?id=27722

gdw

2018-04-28 12:56

developer  

bug_tore.stp (15,501 bytes)

gdw

2018-04-28 12:56

developer   ~0075740

Hello,
The problem seems to be not related to the ellipse but preferably to the BSP subtraction.

In the file bug_tore, if
0000329 = ADVANCED_FACE( '', ( #749 ), #750, .T. );

is replaced by
0000329 = ADVANCED_FACE( '', ( ), #750, .T. );

the tore is read by occ; otherwise, only the cookie is read...

Hope this help
--
Guilhem

gdw

2018-05-01 17:33

developer  

Capture d’écran 2018-05-01 à 16.32.27.png (49,193 bytes)

gdw

2018-05-01 17:34

developer  

Capture d’écran 2018-05-01 à 16.32.54.png (84,779 bytes)

gdw

2018-05-01 17:39

developer   ~0075755

Hi,

After investigations, the problem seems to come from the way the tore is cut by the wire in the ADVANCED_FACE: the part that should kept is 'outside' while occ keeps 'inside', as shown in the screenshots (the yellow one is correct while the gray one is what occ produces).
Currently I am trying to investigate in BrepMesh_FastDiscret.cxx that actually triangule the tore...
Help will infinitely appreciated!
--
Guilhem

gdw

2018-05-12 10:52

developer   ~0075949

More over, the problem seems to come when some B_SPLINE_CURVE_WITH_KNOTS are involved in the EdgeLoop of the ADVANCED_FACE; not sure that the problem is limited if the surface of the ADVANCED_FACE is a torus...
Feedback and help greatly appreciated!

gdw

2018-05-18 08:16

developer   ~0076020

We have temporarily fixed the problem by suppressing the edge part of the advanced face if the target form is a toroids and if the edges are made exclusively with knots surface. This inly a work around...

gdw

2018-08-19 13:14

developer   ~0078684

For more information, the problem comes from FACE_OUTER_BOUND...

git

2020-11-18 11:25

administrator   ~0096872

Branch CR28414 has been created by skl.

SHA-1: bb7eb4c1dcfbf802ef04563fa71057a66e5c9354


Detailed log of new commits:

Author: skl
Date: Wed Nov 18 11:25:19 2020 +0300

    0028414: Step entity not correctly read.
    
    Temporary check

git

2020-11-18 17:20

administrator   ~0096888

Branch CR28414 has been updated forcibly by skl.

SHA-1: 004ecab95df2de6782e447fe3c11a6476e1aa640

git

2020-11-21 06:56

administrator   ~0096926

Branch CR28414 has been updated forcibly by skl.

SHA-1: c896d7915a7b5778780886baea246d40d41b5a01

git

2020-11-22 08:49

administrator   ~0096991

Branch CR28414 has been updated by skl.

SHA-1: 619d87b8f54e5c84a51977aab8cefdee64292934


Detailed log of new commits:

Author: skl
Date: Sun Nov 22 08:49:42 2020 +0300

    0028414: Data Exchange - Step entity not correctly read
    
    Check temporary solution.

git

2020-11-23 17:46

administrator   ~0097012

Branch CR28414 has been updated forcibly by skl.

SHA-1: 19a36cbd1a6a827b973504a2f70bc8cc1b016153

git

2020-11-24 07:52

administrator   ~0097019

Branch CR28414 has been updated by skl.

SHA-1: ddcc1b69c480fa442357e07a5008b7f550445c1a


Detailed log of new commits:

Author: skl
Date: Tue Nov 24 07:52:37 2020 +0300

    0028414: Data Exchange - Step entity not correctly read
    
    Temporary check

git

2020-11-24 15:14

administrator   ~0097031

Branch CR28414 has been updated by skl.

SHA-1: fb9dc489fa78bf7b76a0d9b8d94ca5141f068d5a


Detailed log of new commits:

Author: skl
Date: Tue Nov 24 15:13:57 2020 +0300

    0028414: Data Exchange - Step entity not correctly read
    
    Next version of fix.

skl

2020-11-27 11:23

developer  

bug28414.stp (15,505 bytes)

skl

2020-11-27 11:25

developer   ~0097105

Please add attached file bug28414.stp to repository.

git

2020-11-27 11:32

administrator   ~0097106

Branch CR28414 has been updated forcibly by skl.

SHA-1: 1269f76c49956bd40f960e68df86c7cad3d5c44b

git

2020-11-30 09:41

administrator   ~0097147

Branch CR28414 has been updated forcibly by skl.

SHA-1: 6284b2343419ec0f0e6ce085f654cfa68ffe34d1

git

2020-11-30 09:51

administrator   ~0097148

Branch CR28414 has been updated forcibly by skl.

SHA-1: c7f54f5a958998dc3e8bdd82bd832e42c5c671a7

git

2020-11-30 11:28

administrator   ~0097152

Branch CR28414 has been updated forcibly by skl.

SHA-1: 05acd7b3ff27b5f086fdf150204e04e8a72f7b59

git

2020-11-30 11:49

administrator   ~0097157

Branch CR28414 has been updated forcibly by skl.

SHA-1: 2f271272bc9a0b891641f40e065b5033f6809609

git

2020-12-01 11:21

administrator   ~0097188

Branch CR28414 has been updated forcibly by skl.

SHA-1: 1845b616e017458971d19fba0a48b344231bacd2

skl

2020-12-01 11:24

developer   ~0097189

For entity FACE_BOUND if surface is torus and orientation is True temporary natural bound is created. Later in the ShapeFix_Face this bound is removed but special flag myTorusReverseFlag is activated. Value of this flag is used for decision what part of torus must be used.

Result of tests:
http://vm-jenkins-test-12.nnov.opencascade.com:8080/view/CR28414-master-skl/view/COMPARE/

gka

2020-12-02 18:26

developer   ~0097252

Dear Sergey.

Could you please return previous formatting and add detail comments for new flag added for healing of toroidal faces and modified behavior.

git

2020-12-03 10:05

administrator   ~0097257

Branch CR28414 has been updated forcibly by skl.

SHA-1: 88f4030f0529b339d964d492b4fc69e14f6486c7

skl

2020-12-03 12:10

developer   ~0097263

Result of tests:
http://vm-jenkins-test-12.nnov.opencascade.com:8080/view/CR28414-master-skl/view/COMPARE/

gka

2020-12-04 12:47

developer   ~0097316

Dear Andrey.

Could you please review this fix.

msv

2022-01-18 17:56

developer   ~0106451

Last edited: 2022-03-24 14:27

Dear Andrey, please rebase the patch, review the source code and re-test it.

git

2022-04-06 19:08

administrator   ~0107668

Branch CR28414 has been updated by atereshi.

SHA-1: 5df2ff62a692fdee684db97f3c2e901732315c4e


Detailed log of new commits:

Author: atereshi
Date: Wed Apr 6 19:06:55 2022 +0300

    Merge remote-tracking branch 'origin/CR28414' into CR28414

Author: skl
Date: Wed Nov 18 11:25:19 2020 +0300

    0028414: Data Exchange - Step entity not correctly read
    
    Fix + test.
    For entity FACE_BOUND if surface is torus and orientation is True temporary natural bound is created. Later in the ShapeFix_Face this bound is removed but special flag myTorusReverseFlag is activated. Value of this flag is used for decision what part of torus must be used.

git

2022-04-11 16:55

administrator   ~0107850

Branch CR28414_1 has been created by atereshi.

SHA-1: 5c8108bf05f31d2c34c7a4a8f84e1d1fea939593


Detailed log of new commits:

Author: atereshi
Date: Mon Apr 11 16:54:45 2022 +0300

    0032922: Some refactoring. Added extra analysis in UV-space for toroidal surface.

Author: atereshi
Date: Mon Apr 11 15:26:42 2022 +0300

    0032922: Some refactoring. Added extra analysis in UV-space for toroidal surface.

Author: atereshi
Date: Tue Apr 5 16:25:36 2022 +0300

    0028414: some refactoring

Author: atereshi
Date: Tue Apr 5 11:58:50 2022 +0300

    0028414: some refactoring

Author: atereshi
Date: Mon Apr 4 20:50:08 2022 +0300

    0028414: swap FixAddNaturalBound and FixOrientation

Author: atereshi
Date: Fri Apr 1 14:28:55 2022 +0300

    0028414: Code refactoring. Patch rollback.

git

2022-04-25 16:29

administrator   ~0108160

Branch CR28414_1 has been deleted by atereshi.

SHA-1: 5c8108bf05f31d2c34c7a4a8f84e1d1fea939593

git

2022-04-26 10:45

administrator   ~0108182

Branch CR28414_plus_32922 has been created by atereshi.

SHA-1: 95a26d73124d1bde9ffdbef7885dd93b8e8689ab


Detailed log of new commits:

Author: atereshi
Date: Tue Apr 26 10:45:37 2022 +0300

    fixed theMapWires.UnBind

Author: atereshi
Date: Tue Apr 26 10:07:02 2022 +0300

    code formating

Author: atereshi
Date: Tue Apr 26 09:20:45 2022 +0300

    code formating

Author: atereshi
Date: Tue Apr 5 11:58:50 2022 +0300

    0028414: some refactoring

Author: atereshi
Date: Tue Apr 5 16:25:36 2022 +0300

    0028414: some refactoring

Author: atereshi
Date: Mon Apr 11 15:26:42 2022 +0300

    0032922: Some refactoring. Added extra analysis in UV-space for toroidal surface.

Author: atereshi
Date: Mon Apr 11 16:54:45 2022 +0300

    0032922: Some refactoring. Added extra analysis in UV-space for toroidal surface.

Author: skl
Date: Wed Nov 18 11:25:19 2020 +0300

    0028414: Data Exchange - Step entity not correctly read
    
    Fix + test.
    For entity FACE_BOUND if surface is torus and orientation is True temporary natural bound is created. Later in the ShapeFix_Face this bound is removed but special flag myTorusReverseFlag is activated. Value of this flag is used for decision what part of torus must be used.

Author: atereshi
Date: Fri Apr 1 14:28:55 2022 +0300

    0028414: Code refactoring. Patch rollback.

Author: atereshi
Date: Mon Apr 4 20:50:08 2022 +0300

    0028414: swap FixAddNaturalBound and FixOrientation

git

2022-04-27 11:55

administrator   ~0108218

Branch CR28414_plus_32922 has been updated by atereshi.

SHA-1: 7e9c06281d2e1b96ce927dc191f4ffe93707f60f


Detailed log of new commits:

Author: atereshi
Date: Wed Apr 27 11:54:45 2022 +0300

    if the face has seam edge then we ignore FixAddNaturalBound

git

2022-04-27 14:03

administrator   ~0108223

Branch CR28414_plus_32922 has been updated by atereshi.

SHA-1: 815a6671ab49b9362e4614223217532fa8beea53


Detailed log of new commits:

Author: atereshi
Date: Wed Apr 27 14:03:37 2022 +0300

    if the face has degenerated edge then we ignore FixAddNaturalBound

Issue History

Date Modified Username Field Change
2017-01-30 19:28 gdw New Issue
2017-01-30 19:28 gdw Assigned To => san
2017-01-30 19:28 gdw File Added: StepBug.zip
2017-01-30 19:36 san Assigned To san => gka
2017-01-30 19:36 san Category PRODUCTS:Volume Rendering => OCCT:Data Exchange
2017-01-31 09:47 abv Note Added: 0063235
2017-08-30 14:57 mkv Test case number => bugs step bug28414
2017-10-02 15:45 apv Test case number bugs step bug28414 => Not required
2018-01-02 12:25 gdw Note Added: 0073218
2018-01-04 04:34 eryar Note Added: 0073228
2018-04-28 12:56 gdw File Added: bug_tore.stp
2018-04-28 12:56 gdw Note Added: 0075740
2018-05-01 17:33 gdw File Added: Capture d’écran 2018-05-01 à 16.32.27.png
2018-05-01 17:34 gdw File Added: Capture d’écran 2018-05-01 à 16.32.54.png
2018-05-01 17:39 gdw Note Added: 0075755
2018-05-12 10:52 gdw Note Added: 0075949
2018-05-18 08:16 gdw Note Added: 0076020
2018-05-26 21:10 abv Target Version => 7.4.0
2018-05-26 21:10 abv Relationship added related to 0029564
2018-08-19 13:14 gdw Note Added: 0078684
2019-09-04 15:36 abv Target Version 7.4.0 => 7.5.0
2020-09-17 19:49 gka Target Version 7.5.0 => 7.6.0
2020-11-12 13:54 szy Assigned To gka => skl
2020-11-12 13:54 szy Status new => assigned
2020-11-18 11:25 git Note Added: 0096872
2020-11-18 11:40 kgv Summary Step entity not correctly read. => Data Exchange - Step entity not correctly read
2020-11-18 17:20 git Note Added: 0096888
2020-11-21 06:56 git Note Added: 0096926
2020-11-22 08:49 git Note Added: 0096991
2020-11-23 17:46 git Note Added: 0097012
2020-11-24 07:52 git Note Added: 0097019
2020-11-24 15:14 git Note Added: 0097031
2020-11-27 11:23 skl File Added: bug28414.stp
2020-11-27 11:25 skl Note Added: 0097105
2020-11-27 11:32 git Note Added: 0097106
2020-11-30 09:41 git Note Added: 0097147
2020-11-30 09:51 git Note Added: 0097148
2020-11-30 11:28 git Note Added: 0097152
2020-11-30 11:49 git Note Added: 0097157
2020-12-01 11:21 git Note Added: 0097188
2020-12-01 11:24 skl Note Added: 0097189
2020-12-01 11:24 skl Assigned To skl => gka
2020-12-01 11:24 skl Status assigned => resolved
2020-12-01 11:24 skl Steps to Reproduce Updated
2020-12-02 18:26 gka Note Added: 0097252
2020-12-02 18:26 gka Assigned To gka => skl
2020-12-02 18:26 gka Status resolved => assigned
2020-12-03 10:05 git Note Added: 0097257
2020-12-03 12:10 skl Note Added: 0097263
2020-12-03 12:10 skl Assigned To skl => gka
2020-12-03 12:10 skl Status assigned => resolved
2020-12-04 12:47 gka Note Added: 0097316
2020-12-04 12:47 gka Assigned To gka => abv
2020-12-04 12:47 gka Status resolved => assigned
2020-12-04 12:48 gka Assigned To abv => gka
2020-12-04 12:48 gka Status assigned => resolved
2020-12-09 13:49 abv Assigned To gka => abv
2020-12-12 07:45 abv Relationship added related to 0027722
2021-11-01 18:16 szy Target Version 7.6.0 => 7.7.0
2022-01-18 17:54 msv Assigned To abv => ssafarov
2022-01-18 17:54 msv Status resolved => assigned
2022-01-18 17:56 msv Note Added: 0106451
2022-03-24 14:26 msv Assigned To ssafarov => atereshi
2022-03-24 14:27 msv Note Edited: 0106451
2022-04-06 19:08 git Note Added: 0107668
2022-04-11 16:55 git Note Added: 0107850
2022-04-25 16:29 git Note Added: 0108160
2022-04-26 10:45 git Note Added: 0108182
2022-04-27 11:55 git Note Added: 0108218
2022-04-27 14:03 git Note Added: 0108223